"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FILE_SIZE_THRESHOLD = void 0;
exports.ArtifactsTree = ArtifactsTree;
const react_1 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const evangelist_elements_icon_1 = require("@teambit/evangelist.elements.icon");
const ui_foundation_ui_tree_tree_node_1 = require("@teambit/ui-foundation.ui.tree.tree-node");
const ui_foundation_ui_tree_drawer_1 = require("@teambit/ui-foundation.ui.tree.drawer");
const ui_foundation_ui_tree_file_tree_1 = require("@teambit/ui-foundation.ui.tree.file-tree");
const component_ui_artifacts_models_component_artifacts_model_1 = require("@teambit/component.ui.artifacts.models.component-artifacts-model");
const base_ui_graph_tree_tree_context_1 = require("@teambit/base-ui.graph.tree.tree-context");
const design_ui_skeletons_sidebar_loader_1 = require("@teambit/design.ui.skeletons.sidebar-loader");
const is_binary_path_1 = __importDefault(require("is-binary-path"));
const ui_foundation_ui_tree_folder_tree_node_1 = require("@teambit/ui-foundation.ui.tree.folder-tree-node");
const code_ui_hooks_use_code_params_1 = require("@teambit/code.ui.hooks.use-code-params");
const base_ui_utils_string_affix_1 = require("@teambit/base-ui.utils.string.affix");
const component_1 = require("@teambit/component");
const component_ui_artifacts_queries_use_component_artifacts_1 = require("@teambit/component.ui.artifacts.queries.use-component-artifacts");
const pretty_bytes_1 = __importDefault(require("pretty-bytes"));
const artifact_file_node_clicked_1 = require("./artifact-file-node-clicked");
const artifacts_tree_module_scss_1 = __importDefault(require("./artifacts-tree.module.scss"));
exports.FILE_SIZE_THRESHOLD = 10000;
function ArtifactsTree({ getIcon, drawerName, drawerOpen, onToggleDrawer, host }) {
    const urlParams = (0, code_ui_hooks_use_code_params_1.useCodeParams)();
    const component = (0, react_1.useContext)(component_1.ComponentContext);
    const { data: artifacts = [], loading } = (0, component_ui_artifacts_queries_use_component_artifacts_1.useComponentArtifacts)(host, component.id.toString());
    const [artifactFiles, artifactFilesTree] = (0, react_1.useMemo)(() => {
        const files = (artifacts.length > 0 &&
            artifacts.flatMap((artifact) => artifact.files.map((file) => (Object.assign(Object.assign({}, file), { id: `${artifact.taskName}/${artifact.name}/${file.path}` }))))) ||
            [];
        const _artifactFilesTree = files.map((file) => file.id);
        return [files, _artifactFilesTree];
    }, [loading]);
    const hasArtifacts = artifacts.length > 0;
    const artifactDetailsFromUrl = (0, component_ui_artifacts_models_component_artifacts_model_1.getArtifactFileDetailsFromUrl)(artifacts, urlParams.file);
    const selected = artifactDetailsFromUrl &&
        `${artifactDetailsFromUrl.taskName}/${artifactDetailsFromUrl.artifactName}/${artifactDetailsFromUrl.artifactFile.path}`;
    const payloadMap = (0, react_1.useMemo)(() => {
        const _payloadMap = (hasArtifacts &&
            artifacts.reduce((accum, next) => {
                if (!accum.has(next.taskName))
                    accum.set(`${next.taskName}/`, { open: false });
                return accum;
            }, new Map())) ||
            new Map();
        const { taskName, artifactName, artifactFile } = {
            taskName: artifactDetailsFromUrl === null || artifactDetailsFromUrl === void 0 ? void 0 : artifactDetailsFromUrl.taskName,
            artifactName: artifactDetailsFromUrl === null || artifactDetailsFromUrl === void 0 ? void 0 : artifactDetailsFromUrl.artifactName,
            artifactFile: artifactDetailsFromUrl === null || artifactDetailsFromUrl === void 0 ? void 0 : artifactDetailsFromUrl.artifactFile,
        };
        if (taskName && artifactName && artifactFile) {
            _payloadMap.set(`${taskName}/`, { open: true });
            _payloadMap.set(`${taskName}/${artifactName}/`, { open: true });
            _payloadMap.set(`${taskName}/${artifactName}/${artifactFile.path}`, { open: true });
        }
        return _payloadMap;
    }, [loading, selected]);
    const getHref = (0, react_1.useCallback)((node) => {
        return `~artifact/${node.id}${(0, base_ui_utils_string_affix_1.affix)('?version=', urlParams.version)}`;
    }, [loading]);
    const widgets = (0, react_1.useMemo)(() => [generateWidget(artifactFiles || [], selected)], [loading]);
    if (!hasArtifacts)
        return null;
    return (react_1.default.createElement(ui_foundation_ui_tree_drawer_1.DrawerUI, { isOpen: drawerOpen, onToggle: onToggleDrawer, name: drawerName, contentClass: artifacts_tree_module_scss_1.default.artifactsPanelCodeDrawerContent, className: (0, classnames_1.default)(artifacts_tree_module_scss_1.default.artifactsPanelCodeTabDrawer, drawerOpen && artifacts_tree_module_scss_1.default.openDrawer) },
        loading && react_1.default.createElement(design_ui_skeletons_sidebar_loader_1.ComponentTreeLoader, null),
        loading || (react_1.default.createElement(ui_foundation_ui_tree_file_tree_1.FileTree, { getIcon: getIcon, getHref: getHref, files: artifactFilesTree, widgets: widgets, payloadMap: payloadMap, TreeNode: fileTreeNodeWithArtifactFiles(artifactFiles), selected: selected, onTreeNodeSelected: (id, e) => {
                const matchingArtifactFile = artifactFiles.find((artifactFile) => artifactFile.id === id);
                if (!matchingArtifactFile)
                    return;
                const fileName = getFileNameFromNode(id);
                if ((0, is_binary_path_1.default)(fileName) || matchingArtifactFile.size > exports.FILE_SIZE_THRESHOLD) {
                    (0, artifact_file_node_clicked_1.fileNodeClicked)(artifactFiles, 'download')(e, { id });
                }
            } }))));
}
function getFileNameFromNode(node) {
    const lastIndex = node.lastIndexOf('/');
    return node.slice(lastIndex + 1);
}
function generateWidget(files, selected) {
    return function Widget({ node }) {
        const id = node.id;
        const artifactFile = files.find((file) => file.id === id);
        const path = getFileNameFromNode(id);
        const isBinary = (0, is_binary_path_1.default)(path);
        const isSelected = selected === id;
        if (artifactFile) {
            return (react_1.default.createElement("div", { className: artifacts_tree_module_scss_1.default.artifactWidgets },
                react_1.default.createElement("div", { className: (0, classnames_1.default)(artifacts_tree_module_scss_1.default.size, isSelected && artifacts_tree_module_scss_1.default.selected) }, (0, pretty_bytes_1.default)(artifactFile.size)),
                !isBinary && artifactFile.size <= exports.FILE_SIZE_THRESHOLD && (react_1.default.createElement(evangelist_elements_icon_1.Icon, { className: artifacts_tree_module_scss_1.default.icon, of: "open-tab", onClick: (e) => (0, artifact_file_node_clicked_1.fileNodeClicked)(files, 'new tab')(e, node) })),
                react_1.default.createElement(evangelist_elements_icon_1.Icon, { className: artifacts_tree_module_scss_1.default.icon, of: "download", onClick: (e) => {
                        (0, artifact_file_node_clicked_1.fileNodeClicked)(files, 'download')(e, node);
                    } })));
        }
        return null;
    };
}
function fileTreeNodeWithArtifactFiles(artifactFiles) {
    return function FileTreeNode(props) {
        var _a, _b, _c;
        const { node } = props;
        const { id } = node;
        const fileTreeContext = (0, ui_foundation_ui_tree_file_tree_1.useFileTreeContext)();
        const { selected, onSelect } = (0, react_1.useContext)(base_ui_graph_tree_tree_context_1.TreeContext);
        const href = (_a = fileTreeContext === null || fileTreeContext === void 0 ? void 0 : fileTreeContext.getHref) === null || _a === void 0 ? void 0 : _a.call(fileTreeContext, node);
        const widgets = fileTreeContext === null || fileTreeContext === void 0 ? void 0 : fileTreeContext.widgets;
        const icon = (_b = fileTreeContext === null || fileTreeContext === void 0 ? void 0 : fileTreeContext.getIcon) === null || _b === void 0 ? void 0 : _b.call(fileTreeContext, node);
        const path = getFileNameFromNode(id);
        const isBinary = (0, is_binary_path_1.default)(path);
        const matchingArtifactFile = artifactFiles.find((artifactFile) => artifactFile.id === node.id);
        const isLink = isBinary || ((_c = matchingArtifactFile === null || matchingArtifactFile === void 0 ? void 0 : matchingArtifactFile.size) !== null && _c !== void 0 ? _c : 0) > exports.FILE_SIZE_THRESHOLD;
        if (!(node === null || node === void 0 ? void 0 : node.children)) {
            return (react_1.default.createElement(ui_foundation_ui_tree_tree_node_1.TreeNode, Object.assign({}, props, { className: (0, classnames_1.default)(artifacts_tree_module_scss_1.default.node, isLink && artifacts_tree_module_scss_1.default.link), onClick: onSelect && ((e) => onSelect(node.id, e)), href: href, isActive: (node === null || node === void 0 ? void 0 : node.id) === selected, icon: icon, widgets: widgets })));
        }
        return react_1.default.createElement(ui_foundation_ui_tree_folder_tree_node_1.FolderTreeNode, Object.assign({}, props));
    };
}
//# sourceMappingURL=artifacts-tree.js.map